/// <reference types="react" />
/// <reference types="showdown" />
import * as React from 'react';
import * as Showdown from 'showdown';
import { Command } from './types/Command';
import { CommandSet } from './types/CommandSet';
import { Value } from './types/Value';
export interface ReactMdeProps {
    commands: Array<Array<Command | CommandSet>>;
    value: Value;
    onChange: (value: Value) => void;
    textAreaProps: any;
}
export declare class ReactMde extends React.Component<ReactMdeProps> {
    converter: Showdown.Converter;
    textArea: HTMLTextAreaElement;
    preview: HTMLDivElement;
    constructor();
    /**
     * Handler for the textArea value change
     * @param {any} e
     * @memberOf ReactMde
     */
    handleValueChange: (e: React.FormEvent<HTMLTextAreaElement>) => void;
    /**
     * Executes a command
     * @param {function} command
     * @memberOf ReactMde
     */
    executeCommand: (command: Command) => void;
    componentDidUpdate(): void;
    /**
     * Renders react-mde
     * @returns
     * @memberOf ReactMde
     */
    render(): JSX.Element;
}
